javax.resource.spi.endpoint

## Interface MessageEndpointFactory

-     public interface MessageEndpointFactory

  This serves as a factory for creating message endpoints.
  Version:
    1.0
  Author:
    Ram Jeyaraman

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `MessageEndpoint` | `createEndpoint(javax.transaction.xa.XAResource xaResource)` This is used to create a message endpoint.
    `MessageEndpoint` | `createEndpoint(javax.transaction.xa.XAResource xaResource, long timeout)` This is used to create a message endpoint.
    `java.lang.String` | `getActivationName()` Returns a unique name for the message endpoint deployment represented by the MessageEndpointFactory.
    `java.lang.Class<?>` | `getEndpointClass()` Return the `Class` object corresponding to the message endpoint class.
    `boolean` | `isDeliveryTransacted(java.lang.reflect.Method method)` This is used to find out whether message deliveries to a target method on a message listener interface that is implemented by a message endpoint will be transacted or not.

- - ### Method Detail

    - #### createEndpoint

          MessageEndpoint createEndpoint(javax.transaction.xa.XAResource xaResource)
                                  throws UnavailableException

      This is used to create a message endpoint. The message endpoint is expected to implement the correct message listener type.
      Parameters:
        `xaResource` - an optional `XAResource` instance used to get transaction notifications when the message delivery is transacted.
      Returns:
        a message endpoint instance.
      Throws:
        `UnavailableException` - indicates a transient failure in creating a message endpoint. Subsequent attempts to create a message endpoint might succeed.

    - #### createEndpoint

          MessageEndpoint createEndpoint(javax.transaction.xa.XAResource xaResource,
                                         long timeout)
                                  throws UnavailableException

      This is used to create a message endpoint. The message endpoint is expected to implement the correct message listener type.
      Parameters:
        `xaResource` - an optional `XAResource` instance used to get transaction notifications when the message delivery is transacted.
        `timeout` - an optional value used to specify the time duration (in milliseconds) within which the message endpoint needs to be created by the `MessageEndpointFactory`. Otherwise, the `MessageEndpointFactory` rejects the creation of the `MessageEndpoint` with an UnavailableException. Note, this does not offer real-time guarantees.
      Returns:
        a message endpoint instance.
      Throws:
        `UnavailableException` - indicates a transient failure in creating a message endpoint. Subsequent attempts to create a message endpoint might succeed.
      Since:
        1.6

    - #### isDeliveryTransacted

          boolean isDeliveryTransacted(java.lang.reflect.Method method)
                                throws java.lang.NoSuchMethodException

      This is used to find out whether message deliveries to a target method on a message listener interface that is implemented by a message endpoint will be transacted or not. The message endpoint may indicate its transacted delivery preferences (at a per method level) through its deployment descriptor. The message delivery preferences must not change during the lifetime of a message endpoint.
      Parameters:
        `method` - description of a target method. This information about the intended target method allows an application server to find out whether the target method call will be transacted or not.
      Returns:
        true, if message endpoint requires transacted message delivery.
      Throws:
        `java.lang.NoSuchMethodException` - indicates that the specified method does not exist on the target endpoint.

    - #### getActivationName

          java.lang.String getActivationName()

      Returns a unique name for the message endpoint deployment represented by the MessageEndpointFactory. If the message endpoint has been deployed into a clustered application server then this method must return the same name for that message endpoints activation in each application server instance. It is recommended that this name be human-readable since this name may be used by the resource adapter in ways that may be visible to a user or administrator. It is also recommended that this name remain unchanged even in cases when the application server is restarted or the message endpoint redeployed.
      Returns:
        a new `String` instance representing the unique name of the message endpoint deployment
      Since:
        1.7

    - #### getEndpointClass

          java.lang.Class<?> getEndpointClass()

      Return the `Class` object corresponding to the message endpoint class. For example, for a Message Driven Bean this is the `Class` object corresponding to the application's MDB class. The resource adapter may use this to introspect the message endpoint class to discover annotations, interfaces implemented, etc. and modify the behavior of the resource adapter accordingly. A return value of `null` indicates that the MessageEndpoint doesn't implement the business methods of underlying message endpoint class.
      Returns:
        A `Class` corresponding to the message endpoint class.
      Since:
        1.7

Copyright © 2014 IronJacamar (http://www.ironjacamar.org)